# @semcore/input-number

[![version](https://img.shields.io/npm/v/@semcore/input-number.svg)](https://www.npmjs.com/@semcore/input-number)
[![downloads](https://img.shields.io/npm/dt/@semcore/input-number.svg)](https://www.npmjs.com/package/@semcore/input-number)
[![License: MIT](https://img.shields.io/badge/License-MIT-green.svg)](https://github.com/semrush/intergalactic/blob/master/LICENSE)

> This component is part of the Intergalactic Design System

### 📖 [Component documentation](https://developer.semrush.com/intergalactic/components/input-number/)

### 🏠 [Design system](https://developer.semrush.com/intergalactic/)

## Install

```sh
npm install intergalactic
```

## Usage

```jsx
import InputNumber from 'intergalactic/input-number';
```

<details>
  <summary>Alternative installation and use</summary>

**We do not recommend this usage path due to possible dependency and update issues.**

### Install

You can only install one package from the design system

```sh
npm install @semcore/input-number @semcore/core
```

`@semcore/core` - _is the basic package by which we create our components, and it contains all of the common logic
of the components that is discussed below. There should only be one version of the package in the project._

### Usage

You can use the package the same way but without `/ui/` in the import path.

```jsx
import InputNumber from '@semcore/input-number';
```

</details>

## 👤 Author

[UI-kit team](https://github.com/semrush/intergalactic/blob/master/MAINTAINERS) and [others ❤️](https://github.com/semrush/intergalactic/graphs/contributors)

## 🤝 Contributing

Contributions, issues and feature requests are welcome!

Feel free to check [issues page](https://github.com/semrush/intergalactic/issues). You can also take a look at the [contributing guide](https://github.com/semrush/intergalactic/blob/master/CONTRIBUTING.md).

## Show your support

Give a ⭐️ if this project helped you!

## 📝 License

This project is [MIT](https://github.com/semrush/intergalactic/blob/master/LICENSE) licensed.
