import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import { createComponent, sstyled, assignProps, Component } from "@semcore/core";
import React from "react";
import Input from "@semcore/input";
import { IncrementIcon, DecrementIcon } from "./buttons.mjs";
import { localizedMessages } from "./translations/__intergalactic-dynamic-locales.mjs";
import i18nEnhance from "@semcore/core/lib/utils/enhances/i18nEnhance";
import { forkRef } from "@semcore/core/lib/utils/ref";
import { callAllEventHandlers } from "@semcore/core/lib/utils/assignProps";
/*!__reshadow-styles__:"./style/input-number.shadow.css"*/
var style = (
  /*__reshadow_css_start__*/
  (sstyled.insert(
    /*__inner_css_start__*/
    ".___SValue_og6bd_gg_:focus~.___SControls_og6bd_gg_{display:flex}.___SControls_og6bd_gg_{display:none;flex-flow:column;justify-content:center;height:100%;box-sizing:border-box}.___SControls_og6bd_gg_.__showControls_og6bd_gg_{display:flex}.___SDown_og6bd_gg_,.___SUp_og6bd_gg_{padding:0;width:16px;color:var(--intergalactic-icon-secondary-neutral, #a9abb6);box-sizing:border-box;display:inline-flex;justify-content:center;border:0;background:0 0;cursor:pointer}.___SDown_og6bd_gg_:focus,.___SUp_og6bd_gg_:focus{outline:0}@media (hover:hover){.___SDown_og6bd_gg_:hover,.___SUp_og6bd_gg_:hover{color:var(--intergalactic-icon-secondary-neutral-hover-active, #878992)}}.___SUp_og6bd_gg_{padding-bottom:1px}.___SDown_og6bd_gg_{padding-top:1px}.___SValue_og6bd_gg_::-webkit-inner-spin-button,.___SValue_og6bd_gg_::-webkit-outer-spin-button{-webkit-appearance:none;margin:0}.___SValue_og6bd_gg_._type_number_og6bd_gg_{-moz-appearance:textfield}.___SValue_og6bd_gg_.__disabled_og6bd_gg_~.___SControls_og6bd_gg_{opacity:var(--intergalactic-disabled-opacity, 0.3);cursor:default;pointer-events:none}.___SValueHidden_og6bd_gg_{position:absolute;top:0;width:1px;height:1px;padding:0;overflow:hidden}",
    /*__inner_css_end__*/
    "og6bd_gg_"
  ), /*__reshadow_css_end__*/
  {
    "__SValue": "___SValue_og6bd_gg_",
    "__SControls": "___SControls_og6bd_gg_",
    "_showControls": "__showControls_og6bd_gg_",
    "__SUp": "___SUp_og6bd_gg_",
    "__SDown": "___SDown_og6bd_gg_",
    "_disabled": "__disabled_og6bd_gg_",
    "__SValueHidden": "___SValueHidden_og6bd_gg_",
    "_type_number": "_type_number_og6bd_gg_"
  })
);
function parseValueWithMinMax(value) {
  var min = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : Number.MIN_SAFE_INTEGER;
  var max = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : Number.MAX_SAFE_INTEGER;
  return Math.max(min, Math.min(max, value));
}
var InputNumber = /* @__PURE__ */ function(_Component) {
  _inherits(InputNumber2, _Component);
  var _super = _createSuper(InputNumber2);
  function InputNumber2() {
    var _this;
    _classCallCheck(this, InputNumber2);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "inputRef", /* @__PURE__ */ React.createRef());
    _defineProperty(_assertThisInitialized(_this), "increment", function(event) {
      var _this$inputRef$curren, _this$inputRef$curren2;
      (_this$inputRef$curren = _this.inputRef.current) === null || _this$inputRef$curren === void 0 ? void 0 : (_this$inputRef$curren2 = _this$inputRef$curren.stepUp) === null || _this$inputRef$curren2 === void 0 ? void 0 : _this$inputRef$curren2.call(_this$inputRef$curren, event);
    });
    _defineProperty(_assertThisInitialized(_this), "decrement", function(event) {
      var _this$inputRef$curren3, _this$inputRef$curren4;
      (_this$inputRef$curren3 = _this.inputRef.current) === null || _this$inputRef$curren3 === void 0 ? void 0 : (_this$inputRef$curren4 = _this$inputRef$curren3.stepDown) === null || _this$inputRef$curren4 === void 0 ? void 0 : _this$inputRef$curren4.call(_this$inputRef$curren3, event);
    });
    return _this;
  }
  _createClass(InputNumber2, [{
    key: "getValueProps",
    value: function getValueProps() {
      var numberFormatter = new Intl.NumberFormat(this.asProps.locale, {
        style: "decimal"
      });
      return {
        inputRef: this.inputRef,
        increment: this.increment,
        decrement: this.decrement,
        numberFormatter
      };
    }
  }, {
    key: "getControlsProps",
    value: function getControlsProps() {
      var _this$asProps = this.asProps, size = _this$asProps.size, getI18nText = _this$asProps.getI18nText;
      return {
        size,
        increment: this.increment,
        decrement: this.decrement,
        getI18nText
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _ref = this.asProps, _ref4;
      var SInputNumber = Input;
      return _ref4 = sstyled(this.asProps.style), /* @__PURE__ */ React.createElement(SInputNumber, _ref4.cn("SInputNumber", _objectSpread({}, assignProps({}, _ref))));
    }
  }]);
  return InputNumber2;
}(Component);
_defineProperty(InputNumber, "displayName", "InputNumber");
_defineProperty(InputNumber, "style", style);
_defineProperty(InputNumber, "enhance", [i18nEnhance(localizedMessages)]);
_defineProperty(InputNumber, "defaultProps", {
  size: "m",
  i18n: localizedMessages,
  locale: "en"
});
var Value = /* @__PURE__ */ function(_Component2) {
  _inherits(Value2, _Component2);
  var _super2 = _createSuper(Value2);
  function Value2() {
    var _this2;
    _classCallCheck(this, Value2);
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    _this2 = _super2.call.apply(_super2, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this2), "valueInputRef", /* @__PURE__ */ React.createRef());
    _defineProperty(_assertThisInitialized(_this2), "cursorPosition", -1);
    _defineProperty(_assertThisInitialized(_this2), "getFormattedValue", function(value) {
      return value.replace(new RegExp("[".concat(_this2.separatorThousands, "]"), "g"), "").replace(_this2.separatorDecimal, ".");
    });
    _defineProperty(_assertThisInitialized(_this2), "valueParser", function(value, prevValue, prevDisplayValue) {
      var numberFormatter = _this2.props.numberFormatter;
      var stringNumber = _this2.getFormattedValue(String(value));
      if (Number.isNaN(Number(stringNumber))) {
        return {
          parsedValue: prevValue,
          displayValue: prevDisplayValue
        };
      }
      var displayValue = "";
      if (/\.[0-9]*0$/.test(stringNumber)) {
        var _stringNumber$split = stringNumber.split(_this2.separatorDecimal), _stringNumber$split2 = _slicedToArray(_stringNumber$split, 2), _int = _stringNumber$split2[0], decimal = _stringNumber$split2[1];
        displayValue = numberFormatter.format(_int) + _this2.separatorDecimal + decimal;
      } else if (stringNumber !== "") {
        displayValue = numberFormatter.format(stringNumber);
      }
      return {
        parsedValue: stringNumber,
        displayValue
      };
    });
    _defineProperty(_assertThisInitialized(_this2), "handleValidation", function(event) {
      var _this2$asProps = _this2.asProps, value = _this2$asProps.value, displayValue = _this2$asProps.displayValue, min = _this2$asProps.min, max = _this2$asProps.max, step = _this2$asProps.step;
      var _this2$valueParser = _this2.valueParser(event.currentTarget.value, value, displayValue), parsedValue = _this2$valueParser.parsedValue;
      var roundCoefficient = step < 1 ? step.toString().split(".")[1].length : 1;
      if (Number.isNaN(value) || Number.isNaN(Number.parseFloat(parsedValue))) {
        event.currentTarget.value = "";
        _this2.handlers.value("", event);
      } else {
        var numberValue = parseValueWithMinMax(Number.parseFloat(parsedValue), min, max);
        var rounded = _this2.round(numberValue % step, step);
        if (rounded !== 0) {
          if (rounded >= step / 2) {
            numberValue += step - rounded;
          } else if (Math.abs(rounded) < step) {
            numberValue -= rounded;
          }
        }
        var numberValueRounded = Number(numberValue.toFixed(roundCoefficient));
        _this2.handlers.value(String(numberValueRounded), event);
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "onWheel", function(event) {
      callAllEventHandlers(_this2.asProps.onWheel, _this2.handleWheel)(event);
    });
    _defineProperty(_assertThisInitialized(_this2), "handleWheel", function(event) {
      if (event.target !== _this2.valueInputRef.current) return;
      if (document.activeElement !== _this2.valueInputRef.current) return;
      event.preventDefault();
      if (event.wheelDelta > 0) {
        _this2.stepUp(event);
      } else if (event.wheelDelta < 0) {
        _this2.stepDown(event);
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "handleChange", function(event) {
      var value = _this2.getFormattedValue(event.currentTarget.value);
      var _this2$asProps2 = _this2.asProps, numberFormatter = _this2$asProps2.numberFormatter, prevValue = _this2$asProps2.value;
      if (value === "." || value === "-") {
        _this2.handlers.displayValue(value);
        return false;
      }
      if (value.endsWith("-")) {
        return false;
      }
      if (value.endsWith(".")) {
        if (value.length > prevValue.length) {
          _this2.handlers.displayValue(numberFormatter.format(value) + _this2.separatorDecimal);
          return false;
        } else {
          _this2.handlers.value(value.slice(0, -1), event);
          return false;
        }
      }
      var digits = /[0-9.-]+/.test(value);
      if (digits || value === "") {
        _this2.handlers.value(value, event);
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "handleKeyUp", function(event) {
      if (event.key === "Shift") {
        _this2.cursorPosition = -1;
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "handleKeyDown", function(event) {
      var element = event.currentTarget;
      var value = element.value;
      var length = value.length;
      var displayValue = _this2.asProps.displayValue;
      if (event.key === "." || event.key === ",") {
        if (value.indexOf(_this2.separatorDecimal) === -1 && event.key === ",") {
          event.currentTarget.value = value + ".";
        } else if (value.indexOf(_this2.separatorDecimal) !== -1) {
          event.preventDefault();
          event.stopPropagation();
          return;
        }
      }
      if (event.key === "Backspace" && value.endsWith(_this2.separatorDecimal)) {
        event.preventDefault();
        event.stopPropagation();
        _this2.handlers.displayValue(displayValue.slice(0, -1));
        return false;
      }
      if (element.selectionStart !== length && (event.key === "Backspace" || event.key === _this2.separatorDecimal || ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"].includes(event.key))) {
        var afterSelection = value.slice(element.selectionEnd);
        requestAnimationFrame(function() {
          var newValue = _this2.state.displayValue;
          var index = newValue.lastIndexOf(afterSelection);
          var selectionStart = index;
          var selectionEnd = index;
          element.setSelectionRange(selectionStart, selectionEnd);
        });
      }
      var cursorIndex = 2;
      if (event.shiftKey && _this2.cursorPosition === -1) {
        _this2.cursorPosition = element.selectionStart;
      }
      switch (event.key) {
        case "ArrowLeft": {
          event.preventDefault();
          _this2.moveSelectionLeft(element, cursorIndex);
          break;
        }
        case "ArrowRight": {
          event.preventDefault();
          _this2.moveSelectionRight(element, cursorIndex);
          break;
        }
        case "ArrowDown": {
          event.preventDefault();
          _this2.stepDown(event);
          break;
        }
        case "ArrowUp": {
          event.preventDefault();
          _this2.stepUp(event);
          break;
        }
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "moveSelectionLeft", function(element, cursorIndex) {
      var value = element.value;
      var nextPosition = element.selectionStart - 1 >= 0 ? element.selectionStart - 1 : 0;
      var cursorPosition = value[element.selectionStart - cursorIndex] === _this2.separatorThousands ? element.selectionStart - cursorIndex : nextPosition;
      if (_this2.cursorPosition === -1) {
        element.setSelectionRange(cursorPosition, cursorPosition);
      } else {
        if (element.selectionStart <= _this2.cursorPosition && element.selectionEnd === _this2.cursorPosition) {
          element.setSelectionRange(cursorPosition, element.selectionEnd);
        } else {
          element.setSelectionRange(element.selectionStart, value[element.selectionEnd - cursorIndex] === _this2.separatorThousands ? element.selectionEnd - cursorIndex : element.selectionEnd - 1);
        }
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "moveSelectionRight", function(element, cursorIndex) {
      var value = element.value;
      var nextPosition = element.selectionEnd + 1;
      var cursorPosition = value[element.selectionEnd] === _this2.separatorThousands ? element.selectionEnd + cursorIndex : nextPosition;
      if (_this2.cursorPosition === -1) {
        element.setSelectionRange(cursorPosition, cursorPosition);
      } else {
        if (element.selectionEnd >= _this2.cursorPosition && element.selectionStart === _this2.cursorPosition) {
          element.setSelectionRange(element.selectionStart, cursorPosition);
        } else {
          element.setSelectionRange(value[element.selectionStart] === _this2.separatorThousands ? element.selectionStart + cursorIndex : element.selectionStart + 1, element.selectionEnd);
        }
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "handleClick", function(event) {
      var element = event.target;
      var value = element.value;
      if (value[element.selectionStart - 1] === _this2.separatorThousands) {
        element.setSelectionRange(element.selectionStart - 1, element.selectionEnd - 1);
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "handleBlur", function(event) {
      _this2.cursorPosition = -1;
      _this2.handleValidation(event);
    });
    _defineProperty(_assertThisInitialized(_this2), "stepUp", function(event) {
      var _this2$asProps3 = _this2.asProps, _this2$asProps3$max = _this2$asProps3.max, max = _this2$asProps3$max === void 0 ? Number.MAX_SAFE_INTEGER : _this2$asProps3$max, min = _this2$asProps3.min, step = _this2$asProps3.step, value = _this2$asProps3.value;
      var numberValue;
      if (value === "") {
        numberValue = min !== null && min !== void 0 ? min : 0;
      } else {
        numberValue = Number.parseFloat(value);
      }
      if (!Number.isNaN(numberValue)) {
        var newValue = numberValue + step <= max ? numberValue + step : max;
        _this2.handlers.value(newValue.toString(), event);
      }
    });
    _defineProperty(_assertThisInitialized(_this2), "stepDown", function(event) {
      var _this2$asProps4 = _this2.asProps, max = _this2$asProps4.max, _this2$asProps4$min = _this2$asProps4.min, min = _this2$asProps4$min === void 0 ? Number.MIN_SAFE_INTEGER : _this2$asProps4$min, step = _this2$asProps4.step, value = _this2$asProps4.value;
      var numberValue;
      if (value === "") {
        numberValue = max !== null && max !== void 0 ? max : 0;
      } else {
        numberValue = Number.parseFloat(value);
      }
      if (!Number.isNaN(numberValue)) {
        var newValue = numberValue - step >= min ? numberValue - step : min;
        _this2.handlers.value(newValue.toString(), event);
      }
    });
    return _this2;
  }
  _createClass(Value2, [{
    key: "uncontrolledProps",
    value: function uncontrolledProps() {
      var _this3 = this;
      return {
        displayValue: null,
        value: [null, function(newValue) {
          var _this3$asProps = _this3.asProps, prevValue = _this3$asProps.value, prevDisplayValue = _this3$asProps.displayValue;
          var _this3$valueParser = _this3.valueParser(newValue, prevValue, prevDisplayValue), parsedValue = _this3$valueParser.parsedValue, displayValue = _this3$valueParser.displayValue;
          _this3.handlers.displayValue(displayValue);
          return parsedValue;
        }]
      };
    }
  }, {
    key: "separatorDecimal",
    get: function get() {
      var numberFormatter = this.props.numberFormatter;
      return numberFormatter.format(11.11).replace(/\d/g, "");
    }
  }, {
    key: "separatorThousands",
    get: function get() {
      var numberFormatter = this.props.numberFormatter;
      return numberFormatter.format(1111).replace(/\d/g, "");
    }
  }, {
    key: "round",
    value: function round(value, step) {
      var countDecimals = Math.floor(step) === step ? 0 : step.toString().split(".")[1].length || 0;
      return countDecimals === 0 ? Number.parseFloat(value) : Number.parseFloat(value).toPrecision(countDecimals);
    }
  }, {
    key: "componentDidMount",
    value: (
      // https://stackoverflow.com/questions/57358640/cancel-wheel-event-with-e-preventdefault-in-react-event-bubbling
      function componentDidMount() {
        var _this$valueInputRef$c;
        (_this$valueInputRef$c = this.valueInputRef.current) === null || _this$valueInputRef$c === void 0 ? void 0 : _this$valueInputRef$c.addEventListener("wheel", this.onWheel);
        var _this$asProps2 = this.asProps, inputRef = _this$asProps2.inputRef, value = _this$asProps2.value;
        if (inputRef.current) {
          inputRef.current.stepUp = this.stepUp;
          inputRef.current.stepDown = this.stepDown;
        }
        if (value !== "") {
          var _this$valueParser = this.valueParser(value, "", ""), displayValue = _this$valueParser.displayValue;
          this.handlers.displayValue(displayValue);
        }
      }
    )
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.value !== this.props.value) {
        var _this$valueParser2 = this.valueParser(this.props.value, prevProps.value, prevProps.displayValue), displayValue = _this$valueParser2.displayValue;
        this.handlers.displayValue(displayValue);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$valueInputRef$c2;
      (_this$valueInputRef$c2 = this.valueInputRef.current) === null || _this$valueInputRef$c2 === void 0 ? void 0 : _this$valueInputRef$c2.removeEventListener("wheel", this.onWheel);
    }
  }, {
    key: "render",
    value: function render() {
      var _ref2 = this.asProps, _ref5;
      var SValue = Input.Value;
      var _this$asProps3 = this.asProps, styles = _this$asProps3.styles, min = _this$asProps3.min, max = _this$asProps3.max, step = _this$asProps3.step, forwardRef = _this$asProps3.forwardRef, inputRef = _this$asProps3.inputRef, displayValue = _this$asProps3.displayValue;
      return _ref5 = sstyled(styles), /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement(SValue, _ref5.cn("SValue", _objectSpread({}, assignProps({
        "autoComplete": "off",
        "onBlur": this.handleValidation,
        "use:onChange": this.handleChange,
        "onKeyDown": this.handleKeyDown,
        "onKeyUp": this.handleKeyUp,
        "onClick": this.handleClick,
        "use:ref": forkRef(this.valueInputRef, inputRef, forwardRef),
        "use:value": displayValue,
        "inputMode": Number.isInteger(step) ? "numeric" : "decimal",
        "min": min,
        "max": max,
        "step": step
      }, _ref2)))));
    }
  }]);
  return Value2;
}(Component);
_defineProperty(Value, "style", style);
_defineProperty(Value, "defaultProps", {
  defaultValue: "",
  defaultDisplayValue: "",
  step: 1
});
function Controls(props) {
  var _ref3 = arguments[0], _ref6;
  var Children = props.Children, increment = props.increment, decrement = props.decrement, size = props.size, styles = props.styles, getI18nText = props.getI18nText;
  var SControls = Input.Addon;
  var SUp = "button";
  var SDown = "button";
  return _ref6 = sstyled(styles), /* @__PURE__ */ React.createElement(SControls, _ref6.cn("SControls", _objectSpread({}, assignProps({
    "aria-hidden": "true"
  }, _ref3))), /* @__PURE__ */ React.createElement(SUp, _ref6.cn("SUp", {
    "onClick": increment,
    "tabIndex": -1,
    "type": "button",
    "size": size,
    "aria-label": getI18nText("increment")
  }), /* @__PURE__ */ React.createElement(IncrementIcon, _ref6.cn("IncrementIcon", {}))), /* @__PURE__ */ React.createElement(SDown, _ref6.cn("SDown", {
    "onClick": decrement,
    "tabIndex": -1,
    "type": "button",
    "size": size,
    "aria-label": getI18nText("decrement")
  }), /* @__PURE__ */ React.createElement(DecrementIcon, _ref6.cn("DecrementIcon", {}))), /* @__PURE__ */ React.createElement(Children, _ref6.cn("Children", {})));
}
Controls.style = style;
const InputNumber$1 = createComponent(InputNumber, {
  Value,
  Controls,
  Addon: Input.Addon
});
export {
  InputNumber$1 as default,
  parseValueWithMinMax
};
